package com.sheelapps.swtml.examples.texteditor;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.MenuItem;

public class ColorListener implements Listener {
	
	public void handleEvent(Event event) {
		Color fg=null;
		MenuItem item = (MenuItem) event.widget;
		if(item.getText().equalsIgnoreCase("Red")) {
			fg = TextEditor.RED;
		}
		else if(item.getText().equalsIgnoreCase("Green")) {
			fg = TextEditor.GREEN;
		}
		else if(item.getText().equalsIgnoreCase("Blue")) {
			fg = TextEditor.BLUE;
		}
		
		Point sel = TextEditor.getStyledText().getSelectionRange();
		if ((sel == null) || (sel.y == 0))
			return;
		StyleRange style, range;
		for (int i = sel.x; i < sel.x + sel.y; i++) {
			range = TextEditor.getStyledText().getStyleRangeAtOffset(i);
			if (range != null) {
				style = (StyleRange) range.clone();
				style.start = i;
				style.length = 1;
				style.foreground = fg;
			} else {
				style = new StyleRange(i, 1, fg, null, SWT.NORMAL);
			}
			TextEditor.getStyledText().setStyleRange(style);
		}
		TextEditor.getStyledText().setSelectionRange(sel.x + sel.y, 0);
	
	}

	
}
