package com.sheelapps.swtml.examples.texteditor;

import java.util.Vector;

import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.MenuItem;

public class CutCopyPasteListener implements Listener {

	public void handleEvent(Event event) {
		MenuItem item = (MenuItem) event.widget;
		if(item.getText().equalsIgnoreCase("Cut")) {
			handleCutCopy();
			TextEditor.getStyledText().cut();
		}
		else if(item.getText().equalsIgnoreCase("Copy")) {
			handleCutCopy();
			TextEditor.getStyledText().copy();
		}
		else if(item.getText().equalsIgnoreCase("Paste")) {
			TextEditor.getStyledText().paste();
		}
	}

	private void handleCutCopy() {
		TextEditor.cachedStyles = new Vector();
		Point sel = TextEditor.getStyledText().getSelectionRange();
		int startX = sel.x;
		for (int i = sel.x; i <= sel.x + sel.y - 1; i++) {
			StyleRange style = TextEditor.getStyledText().getStyleRangeAtOffset(i);
			if (style != null) {
				style.start = style.start - startX;
				if (!TextEditor.cachedStyles.isEmpty()) {
					StyleRange lastStyle = (StyleRange) TextEditor.cachedStyles
							.lastElement();
					if (lastStyle.similarTo(style)
							&& lastStyle.start + lastStyle.length == style.start) {
						lastStyle.length++;
					} else {
						TextEditor.cachedStyles.addElement(style);
					}
				} else {
					TextEditor.cachedStyles.addElement(style);
				}
			}
		}
		
	}

}
